using SnoopPrecompile

@precompile_setup begin
    const _pre_types = (:Float32, :Float64)
    const width = 5
    const nϕ = 11

    @precompile_all_calls begin
        for T ∈ _pre_types, Img ∈ CTTestImages._gs_images, G ∈ Geometry._geometry_names, A ∈ (:Radon, :RadonSquare), F ∈ (:FBP, :FBPAFFT, :FBPAFFTSquare, :FBPFFTSquare)
            @eval begin
                gs = $Img($T; width)
                g = $G(gs; nϕ)
                ct = project_image(gs, g, $A()) |> reconstruct_image($F())
                ctc = calibrate_tomogram(ct, gs)
            end
        end
    end
end
